from MadGraphControl.MadGraphUtils import *

## pcard = open('param_card2.dat','w')
## pcard.write("""

## ######################################################################
## ## PARAM_CARD AUTOMATICALY GENERATED BY MG5 FOLLOWING UFO MODEL   ####
## ######################################################################
## ##                                                                  ##
## ##  Width set on Auto will be computed following the information    ##
## ##        present in the decay.py files of the model. By default,   ##
## ##        this is only 1->2 decay modes.                            ##
## ##                                                                  ##
## ######################################################################

## ###################################
## ## INFORMATION FOR MASS
## ###################################
## Block mass 
##     5 4.700000e+00 # MB 
##     6 1.730000e+02 # MT 
##    15 1.777000e+00 # MTA 
##    23 9.118800e+01 # MZ 
##    25 1.200000e+02 # MH 
## ## Dependent parameters, given by model restrictions.
## ## Those values should be edited following the 
## ## analytical expression. MG5 ignores those values 
## ## but they are important for interfacing the output of MG5
## ## to external program such as Pythia.
##   1 0.000000 # d : 0.0 
##   2 0.000000 # u : 0.0 
##   3 0.000000 # s : 0.0 
##   4 0.000000 # c : 0.0 
##   11 0.000000 # e- : 0.0 
##   12 0.000000 # ve : 0.0 
##   13 0.000000 # mu- : 0.0 
##   14 0.000000 # vm : 0.0 
##   16 0.000000 # vt : 0.0 
##   21 0.000000 # g : 0.0 
##   22 0.000000 # a : 0.0 
##   24 80.419002 # w+ : cmath.sqrt(MZ__exp__2/2. + cmath.sqrt(MZ__exp__4/4. - (aEW*cmath.pi*MZ__exp__2)/(Gf*sqrt__2))) 

## ###################################
## ## INFORMATION FOR SMINPUTS
## ###################################
## Block sminputs 
##     1 1.325070e+02 # aEWM1 
##     2 1.166390e-05 # Gf 
##     3 1.180000e-01 # aS 

## ###################################
## ## INFORMATION FOR YUKAWA
## ###################################
## Block yukawa 
##     5 4.700000e+00 # ymb 
##     6 1.730000e+02 # ymt 
##    15 1.777000e+00 # ymtau 

## ###################################
## ## INFORMATION FOR DECAY
## ###################################
## DECAY   6 1.491500e+00 # WT 
## DECAY  23 2.441404e+00 # WZ 
## DECAY  24 2.047600e+00 # WW 
## DECAY  25 5.753088e-03 # WH 
## ## Dependent parameters, given by model restrictions.
## ## Those values should be edited following the 
## ## analytical expression. MG5 ignores those values 
## ## but they are important for interfacing the output of MG5
## ## to external program such as Pythia.
## DECAY  1 0.000000 # d : 0.0 
## DECAY  2 0.000000 # u : 0.0 
## DECAY  3 0.000000 # s : 0.0 
## DECAY  4 0.000000 # c : 0.0 
## DECAY  5 0.000000 # b : 0.0 
## DECAY  11 0.000000 # e- : 0.0 
## DECAY  12 0.000000 # ve : 0.0 
## DECAY  13 0.000000 # mu- : 0.0 
## DECAY  14 0.000000 # vm : 0.0 
## DECAY  15 0.000000 # ta- : 0.0 
## DECAY  16 0.000000 # vt : 0.0 
## DECAY  21 0.000000 # g : 0.0 
## DECAY  22 0.000000 # a : 0.0

## """)
## pcard.close()

fcard = open('proc_card_mg5_temp.dat','w')
fcard.write("""

import model sm
define j = g u c d s u~ c~ d~ s~
define j = p
define l = e+ e- mu+ mu- ta+ ta-
define ta = ta+ ta-
define vl = ve ve~ vm vm~ vt vt~
generate p p 
output madevent -f

""")
fcard.close()

rcard = open('run_card2.dat','w')
rcard.write("""

#*********************************************************************
#                       MadGraph/MadEvent                            *
#                  http://madgraph.hep.uiuc.edu                      *
#                                                                    *
#                        run_card.dat                                *
#                                                                    *
#  This file is used to set the parameters of the run.               *
#                                                                    *
#  Some notation/conventions:                                        *
#                                                                    *
#   Lines starting with a '# ' are info or comments                  *
#                                                                    *
#   mind the format:   value    = variable     ! comment             *
#*********************************************************************
#
#*******************                                                 
# Running parameters
#*******************                                                 
#                                                                    
#*********************************************************************
# Tag name for the run (one word)                                    *
#*********************************************************************
  tag_vbf3     = run_tag ! name of the run 
#*********************************************************************
# Run to generate the grid pack                                      *
#*********************************************************************
  .false.     = gridpack  !True = setting up the grid pack
#*********************************************************************
# Number of events and rnd seed                                      *
# Warning: Do not generate more than 1M events in a single run       *
# If you want to run Pythia, avoid more than 50k events in a run.    *
#*********************************************************************
  10000 = nevents ! Number of unweighted events requested 
 42 = iseed   ! rnd seed (0=assigned automatically=default))
#*********************************************************************
# Collider type and energy                                           *
# lpp: 0=No PDF, 1=proton, -1=antiproton, 2=photon from proton,      *
#                                         3=photon from electron     *
#*********************************************************************
        1     = lpp1    ! beam 1 type 
        1     = lpp2    ! beam 2 type
     4000     = ebeam1  ! beam 1 total energy in GeV
     4000     = ebeam2  ! beam 2 total energy in GeV
#*********************************************************************
# Beam polarization from -100 (left-handed) to 100 (right-handed)    *
#*********************************************************************
        0     = polbeam1 ! beam polarization for beam 1
        0     = polbeam2 ! beam polarization for beam 2
#*********************************************************************
# PDF CHOICE: this automatically fixes also alpha_s and its evol.    *
#*********************************************************************
 'cteq6l1'    = pdlabel     ! PDF set                                     
#*********************************************************************
# Renormalization and factorization scales                           *
#*********************************************************************
 F        = fixed_ren_scale  ! if .true. use fixed ren scale
 F        = fixed_fac_scale  ! if .true. use fixed fac scale
 91.1880  = scale            ! fixed ren scale
 91.1880  = dsqrt_q2fact1    ! fixed fact scale for pdf1
 91.1880  = dsqrt_q2fact2    ! fixed fact scale for pdf2
 1        = scalefact        ! scale factor for event-by-event scales
#*********************************************************************
# Matching - Warning! ickkw > 1 is still beta
#*********************************************************************
 0        = ickkw            ! 0 no matching, 1 MLM, 2 CKKW matching
 1        = highestmult      ! for ickkw=2, highest mult group
 1        = ktscheme         ! for ickkw=1, 1 Durham kT, 2 Pythia pTE
 1        = alpsfact         ! scale factor for QCD emission vx
 F        = chcluster        ! cluster only according to channel diag
 T        = pdfwgt           ! for ickkw=1, perform pdf reweighting
 5        = asrwgtflavor     ! highest quark flavor for a_s reweight
#*********************************************************************
# Automatic ptj and mjj cuts if xqcut > 0
# (turn off for VBF and single top)
#**********************************************************
   F  = auto_ptj_mjj  ! Automatic setting of ptj and mjj
#**********************************************************
#                                                                    
#**********************************
# BW cutoff (M+/-bwcutoff*Gamma)
#**********************************
  15  = bwcutoff      ! (M+/-bwcutoff*Gamma)
#**********************************************************
# Apply pt/E/eta/dr/mij cuts on decay products or not
# (note that etmiss/ptll/ptheavy/ht/sorted cuts always apply)
#**********************************************************
   T  = cut_decays    ! Cut decay products 
#*************************************************************
# Number of helicities to sum per event (0 = all helicities)
# 0 gives more stable result, but longer run time (needed for
# long decay chains e.g.).
# Use >=2 if most helicities contribute, e.g. pure QCD.
#*************************************************************
   0  = nhel          ! Number of helicities used per event
#*******************                                                 
# Standard Cuts
#*******************                                                 
#                                                                    
#*********************************************************************
# Minimum and maximum pt's (for max, -1 means no cut)                *
#*********************************************************************
 20  = ptj       ! minimum pt for the jets 
  0  = ptb       ! minimum pt for the b 
 35  = pta       ! minimum pt for the photons 
  0  = ptl       ! minimum pt for the charged leptons 
  0  = misset    ! minimum missing Et (sum of neutrino's momenta)
  0  = ptheavy   ! minimum pt for one heavy final state
 1.0 = ptonium   ! minimum pt for the quarkonium states
 -1  = ptjmax    ! maximum pt for the jets
 -1  = ptbmax    ! maximum pt for the b
 -1  = ptamax    ! maximum pt for the photons
 -1  = ptlmax    ! maximum pt for the charged leptons
 -1  = missetmax ! maximum missing Et (sum of neutrino's momenta)
#*********************************************************************
# Minimum and maximum E's (in the lab frame)                         *
#*********************************************************************
  0  = ej     ! minimum E for the jets 
  0  = eb     ! minimum E for the b 
  0  = ea     ! minimum E for the photons 
  0  = el     ! minimum E for the charged leptons 
 -1   = ejmax ! maximum E for the jets
 -1   = ebmax ! maximum E for the b
 -1   = eamax ! maximum E for the photons
 -1   = elmax ! maximum E for the charged leptons
#*********************************************************************
# Maximum and minimum absolute rapidity (for max, -1 means no cut)   *
#*********************************************************************
 5.5  = etaj    ! max rap for the jets 
  -1  = etab    ! max rap for the b
 2.5  = etaa    ! max rap for the photons 
  -1  = etal    ! max rap for the charged leptons 
 0.6  = etaonium ! max rap for the quarkonium states
   0  = etajmin ! min rap for the jets
   0  = etabmin ! min rap for the b
   0  = etaamin ! min rap for the photons
   0  = etalmin ! main rap for the charged leptons
#*********************************************************************
# Minimum and maximum DeltaR distance                                *
#*********************************************************************
 0.4 = drjj    ! min distance between jets 
 0   = drbb    ! min distance between b's 
 0.2 = drll    ! min distance between leptons 
 0.2 = draa    ! min distance between gammas 
 0   = drbj    ! min distance between b and jet 
 0.2 = draj    ! min distance between gamma and jet 
 0.2 = drjl    ! min distance between jet and lepton 
 0   = drab    ! min distance between gamma and b 
 0   = drbl    ! min distance between b and lepton 
 0.2 = dral    ! min distance between gamma and lepton 
 -1  = drjjmax ! max distance between jets
 -1  = drbbmax ! max distance between b's
 -1  = drllmax ! max distance between leptons
 -1  = draamax ! max distance between gammas
 -1  = drbjmax ! max distance between b and jet
 -1  = drajmax ! max distance between gamma and jet
 -1  = drjlmax ! max distance between jet and lepton
 -1  = drabmax ! max distance between gamma and b
 -1  = drblmax ! max distance between b and lepton
 -1  = dralmax ! maxdistance between gamma and lepton
#*********************************************************************
# Minimum and maximum invariant mass for pairs                       *
#*********************************************************************
 350   = mmjj    ! min invariant mass of a jet pair 
 0   = mmbb    ! min invariant mass of a b pair 
 0   = mmaa    ! min invariant mass of gamma gamma pair
 0   = mmll    ! min invariant mass of l+l- (same flavour) lepton pair
 -1  = mmjjmax ! max invariant mass of a jet pair
 -1  = mmbbmax ! max invariant mass of a b pair
 -1  = mmaamax ! max invariant mass of gamma gamma pair
 -1  = mmllmax ! max invariant mass of l+l- (same flavour) lepton pair
#*********************************************************************
# Minimum and maximum invariant mass for all letpons                 *
#*********************************************************************
 0   = mmnl    ! min invariant mass for all letpons (l+- and vl) 
 -1  = mmnlmax ! max invariant mass for all letpons (l+- and vl) 
#*********************************************************************
# Minimum and maximum pt for 4-momenta sum of leptons                *
#*********************************************************************
 0   = ptllmin  ! Minimum pt for 4-momenta sum of leptons(l and vl)
 -1  = ptllmax  ! Maximum pt for 4-momenta sum of leptons(l and vl)
#*********************************************************************
# Inclusive cuts                                                     *
#*********************************************************************
 0  = xptj ! minimum pt for at least one jet  
 0  = xptb ! minimum pt for at least one b 
 35  = xpta ! minimum pt for at least one photon 
 0  = xptl ! minimum pt for at least one charged lepton 
#*********************************************************************
# Control the pt's of the jets sorted by pt                          *
#*********************************************************************
 20   = ptj1min ! minimum pt for the leading jet in pt
 20   = ptj2min ! minimum pt for the second jet in pt
 0   = ptj3min ! minimum pt for the third jet in pt
 0   = ptj4min ! minimum pt for the fourth jet in pt
 -1  = ptj1max ! maximum pt for the leading jet in pt 
 -1  = ptj2max ! maximum pt for the second jet in pt
 -1  = ptj3max ! maximum pt for the third jet in pt
 -1  = ptj4max ! maximum pt for the fourth jet in pt
 0   = cutuse  ! reject event if fails any (0) / all (1) jet pt cuts
#*********************************************************************
# Control the pt's of leptons sorted by pt                           *
#*********************************************************************
 0   = ptl1min ! minimum pt for the leading lepton in pt
 0   = ptl2min ! minimum pt for the second lepton in pt
 0   = ptl3min ! minimum pt for the third lepton in pt
 0   = ptl4min ! minimum pt for the fourth lepton in pt
 -1  = ptl1max ! maximum pt for the leading lepton in pt 
 -1  = ptl2max ! maximum pt for the second lepton in pt
 -1  = ptl3max ! maximum pt for the third lepton in pt
 -1  = ptl4max ! maximum pt for the fourth lepton in pt
#*********************************************************************
# Control the Ht(k)=Sum of k leading jets                            *
#*********************************************************************
 0   = htjmin ! minimum jet HT=Sum(jet pt)
 -1  = htjmax ! maximum jet HT=Sum(jet pt)
 0   = ihtmin  !inclusive Ht for all partons (including b)
 -1  = ihtmax  !inclusive Ht for all partons (including b)
 0   = ht2min ! minimum Ht for the two leading jets
 0   = ht3min ! minimum Ht for the three leading jets
 0   = ht4min ! minimum Ht for the four leading jets
 -1  = ht2max ! maximum Ht for the two leading jets
 -1  = ht3max ! maximum Ht for the three leading jets
 -1  = ht4max ! maximum Ht for the four leading jets
#*********************************************************************
# WBF cuts                                                           *
#*********************************************************************
 0   = xetamin ! minimum rapidity for two jets in the WBF case  
 3.0   = deltaeta ! minimum rapidity for two jets in the WBF case 
#*********************************************************************
# maximal pdg code for quark to be considered as a light jet         *
# (otherwise b cuts are applied)                                     *
#*********************************************************************
 4 = maxjetflavor    ! Maximum jet pdg code
#*********************************************************************
# Jet measure cuts                                                   *
#*********************************************************************
 0   = xqcut   ! minimum kt jet measure between partons
#*********************************************************************

""")
rcard.close()


if runArgs.runNumber==124000:
    myproc = "generate p p > vl vl a j j QED=99 QCD=99"
    nmass = 0
    xqcut = 0
    jetmin = 20
    mjjmin = 350
    detajj = 3.0
    ptj1min = 20
    ptj2min = 20
    photonmin = 35
elif runArgs.runNumber==123999:
    myproc = "generate p p > l vl a j j QED=99 QCD=99"
    nmass = 0
    xqcut = 0
    jetmin = 20
    mjjmin = 350
    detajj = 3.0
    ptj1min = 20
    ptj2min = 20
    photonmin = 35
elif runArgs.runNumber==145000:
    myproc = "generate p p > ta vl j j QED=99 QCD=99"
    nmass = 0
    xqcut = 0
    jetmin = 25
    mjjmin = 550
    detajj = 3.5
    ptj1min = 25
    ptj2min = 25
    photonmin = 0
elif runArgs.runNumber==170000:
    myproc = "generate u u > l vl a u d QED=99 QCD=99"
    nmass = 0
    xqcut = 0
    jetmin = 25
    mjjmin = 550
    detajj = 3.5
    ptj1min = 25
    ptj2min = 25
    photonmin = 0
else:
    print "ERROR: Don't know what to do with runNumber",runArgs.runNumber


# Grab the run card and move it into place
runcard = open('run_card2.dat')
if not os.access('run_card2.dat',os.R_OK):
    print 'ERROR: Could not get run card'
elif os.access('run_card.dat',os.R_OK):
    print 'ERROR: Old run card in the current directory.  Dont want to clobber it.  Please move it first.'
else:
    oldcard = open('run_card2.dat','r')
    newcard = open('run_card.dat','w')
    for line in oldcard:
        if ' xqcut ' in line:
            newcard.write('%f   = xqcut   ! minimum kt jet measure between partons \n'%(xqcut))
        elif ' nevents ' in line:
            newcard.write('  %i       = nevents ! Number of unweighted events requested \n'%(10000))
        elif ' iseed ' in line:
            newcard.write('   %i      = iseed   ! rnd seed (0=assigned automatically=default)) \n'%(runArgs.randomSeed))
        elif ' mmjj ' in line:
            newcard.write('   %i      = mmjj ! min invariant mass of a jet pair \n'%(mjjmin))
        elif ' xptj ' in line:
            newcard.write('   %i      = xptj ! minimum pt for at least one jet \n'%(jetmin))
        elif ' xpta ' in line:
            newcard.write('   %i      = xpta ! minimum pt for at least one photon \n'%(photonmin))
        elif ' deltaeta ' in line:
            newcard.write('   %i      = deltaeta ! minimum rapidity for two jets in the WBF case  \n'%(detajj))
        elif ' ptj1min ' in line:
            newcard.write('   %i      = ptj1min ! minimum pt for the leading jet in pt \n'%(ptj1min))
        elif ' ptj2min ' in line:
            newcard.write('   %i      = ptj2min ! minimum pt for the second jet in pt \n'%(ptj2min))
        elif ' ebeam1 ' in line:
            newcard.write('   %i      = ebeam1  ! beam 1 energy in GeV \n'%(int(runArgs.ecmEnergy/2)))
        elif ' ebeam2 ' in line:
            newcard.write('   %i      = ebeam2  ! beam 2 energy in GeV \n'%(int(runArgs.ecmEnergy/2)))
        else:
            newcard.write(line)
    oldcard.close()
    newcard.close()

## #fix up the param_card.dat
## paramcard = open('param_card2.dat')
## if not os.access('param_card2.dat',os.R_OK):
##     print 'ERROR: Could not get param card'
## elif os.access('param_card.dat',os.R_OK):
##     print 'ERROR: Old param card in the current directory.  Dont want to clobber it.  Please move it first.'
## else:
##     oldcard = open('param_card2.dat','r')
##     newcard = open('param_card.dat','w')
##     for line in oldcard:
##         if '1000022     1.00000000E+02   # ~chi_10' in line:
##             newcard.write('1000022  %f   # ~chi_10\n'%(nmass))
##         else:
##             newcard.write(line)
##     oldcard.close()
##     newcard.close()

#fix up the proc_card_mg5.dat
proccard = open('proc_card_mg5_temp.dat')
if not os.access('proc_card_mg5_temp.dat',os.R_OK):
    print 'ERROR: Could not get proc card temp'
elif os.access('proc_card_mg5.dat',os.R_OK):
    print 'ERROR: Old proc card in the current directory.  Dont want to clobber it.  Please move it first.'
else:
    oldcard = open('proc_card_mg5_temp.dat','r')
    newcard = open('proc_card_mg5.dat','w')
    for line in oldcard:
        if 'generate p p' in line:
            newcard.write('%s \n'%(myproc))
        else:
            newcard.write(line)
    oldcard.close()
    newcard.close()


#########################x
process_dir = new_process()
#generate(run_card_loc='run_card.dat',param_card_loc='param_card.dat',mode=0,njobs=1,run_name='Test',proc_dir=process_dir)
generate(run_card_loc='run_card.dat',param_card_loc=None,mode=0,njobs=1,run_name='Test',proc_dir=process_dir)
stringy = 'madgraph.'+str(runArgs.runNumber)+'.MadGraph_vbf'
skip_events=0
if hasattr(runArgs,'skipEvents'): skip_events=runArgs.skipEvents
arrange_output(run_name='Test',proc_dir=process_dir,outputDS=stringy+'._00001.events.tar.gz',skip_events=skip_events)

#--------------------------------------------------------------
# General MC12 configuration
#--------------------------------------------------------------
from AthenaCommon.AlgSequence import AlgSequence
topAlg = AlgSequence("TopAlg")

#include ( "MC12JobOptions/Pythia_AUET2B_CTEQ6L1_Common.py" )
#Pythia = topAlg.Pythia
#Pythia.PythiaCommand = ["pyinit user madgraph"]
#Pythia.PythiaCommand +=  [
#            "pystat 1 3 4 5",
#            "pyinit dumpr 1 5",
#            "pyinit pylistf 1",
#            ]
##include ( "MC12JobOptions/Pythia_Tauola.py" )
#include ( "MC12JobOptions/Pythia_Photos.py" )

include("MC12JobOptions/Pythia8_AU2_CTEQ6L1_Common.py")
include("MC12JobOptions/Pythia8_MadGraph.py")
include("MC12JobOptions/Pythia8_Photos.py")

## For debugging only: print out some Pythia config info
topAlg.Pythia8.Commands += ["Init:showAllParticleData = on", "Next:numberShowLHA = 10", "Next:numberShowEvent = 10"]

#from MC12JobOptions.MadGraphEvgenConfig import evgenConfig
evgenConfig.generators += ["MadGraph", "Pythia8"]
evgenConfig.description = 'MadGraph_vbf'
evgenConfig.keywords = ["SM","vbf"]
evgenConfig.inputfilecheck = stringy
evgenConfig.minevents = 5000
runArgs.inputGeneratorFile=stringy+'._00001.events.tar.gz'

