# Two-step squark decay to LSP, x1=1/2, x2=1/4, WWZZ (Multi-lepton)
include ( 'MC12JobOptions/MadGraphControl_SimplifiedModelPreInclude.py' )

points2b2q = []
toremove = [210,240,270,300,330,410,490,570,650,730,810,890,970,1050,1130,1197.5]
counter=0
counter2=0
sumList   = [250,310,370,430,490,550,610,770,930,1090,1250,1410,1570,1730,1890,2050,2210,2370,2530,2690,2850]
for sum in ([0,50,100,150,200]+sumList):
    diffI = xrange(1,int(sum/75)+1)
    diffL = [25,50]
    for item in diffI: diffL += [ item*80 ]
    for diff in diffL:
        counter2 += 1
        msq = (sum+diff)/2.
        #remove regions already excluded or unreachable
        if msq>1200 or msq-diff<0 or msq-diff>800 or msq<250: continue
        if msq in toremove: continue
        if msq<=575 and msq-diff<200: continue
        if msq-diff>600 and counter2%2==0: continue
        point = [msq,msq-diff]
        points2b2q += [ point ]

# new two step wwzz
points2b2 = []
sumList   = [250,310,370,430,490,550,610,770,930,1090,1250,1410,1570,1730,1890,2050,2210,2370,2530,2690,2850]
toremove  = [210,240,270,300,330,410,490,570,650,730,810,890,970,1050,1130,1197.5]
counter=0
counter2=0
for sum in ([0,50,100,150,200]+sumList):
    diffI = xrange(1,int(sum/75)+1)
    diffL = [25,50]
    for item in diffI: diffL += [ item*80 ]
    for diff in diffL:
        counter += 1
        msq = (sum+diff)/2.
        #remove regions already excluded or unreachable
        if msq>1500 or msq-diff<0 or msq-diff>800 or msq<250: continue
        if msq in toremove: continue
        if msq<=850 and msq-diff<250: continue
        if msq<910  and msq-diff<100: continue
        if msq-diff>600 and counter%2==0: continue
        if msq-diff>600 and msq>1300: continue
        point = [msq,msq-diff]
        points2b2 += [ point ]

# Original grid points
therun = runArgs.runNumber-173865
if therun>=0 and therun<len(points2b2q):
    evgenLog.info('Registered generation of two-step SS point '+str(therun))
    for q in squarksl: masses[q] = points2b2q[therun][0] # changed to squarksl!
    masses['1000022'] = points2b2q[therun][1]
    masses['1000024'] = 0.5*(points2b2q[therun][0]+points2b2q[therun][1])
    masses['1000023'] = 0.5*(masses['1000024']+points2b2q[therun][1])
    stringy = str(int(points2b2q[therun][0]))+'_'+str(int(masses['1000024']))+'_'+str(int(points2b2q[therun][1]))
    gentype='SS'
    decaytype='twostep'
    njets=1
    use_decays=False
    use_Tauola=False

# Grid extension
pointsSS2step = [[205,45],[245,5],[225,145],[265,105],[305,65],[345,25],[325,165],[365,125],[405,85],[445,45],[485,5],[425,185],[465,145],[505,105],[545,65]]
therun = runArgs.runNumber-179831
if therun>=0 and therun<len(pointsSS2step):
    evgenLog.info('Registered generation of grid extension: SS two step with WWZZ '+str(therun))
    for q in squarksl: masses[q] = pointsSS2step[therun][0]
    masses['1000022'] = pointsSS2step[therun][1]
    masses['1000024'] = 0.5*(pointsSS2step[therun][0]+pointsSS2step[therun][1])
    masses['1000023'] = 0.5*(masses['1000024']+pointsSS2step[therun][1])
    stringy = str(int(pointsSS2step[therun][0]))+'_'+str(int(masses['1000024']))+'_'+str(int(pointsSS2step[therun][1]))
    gentype='SS'
    decaytype='twostep'
    njets=1
    use_decays=False
    use_Tauola=False

# Systematics
therun = runArgs.runNumber-152857
if therun>=0 and therun<5*5:
    evgenLog.info('Registered generation of grid ten systematics, two-step SS point '+str(therun))
    syspoints = [ [235,75], [205,45], [335,95], [325,165], [300,250] ]
    for q in squarks: masses[q] = syspoints[therun%5][0]
    masses['1000022'] = syspoints[therun%5][1]
    masses['1000024'] = 0.5*(syspoints[therun%5][0]+syspoints[therun%5][1])
    masses['1000023'] = 0.5*(masses['1000024']+syspoints[therun%5][1])
    syst_mod='qup'
    if therun>=5: syst_mod='qdown'
    if therun>=10: syst_mod='radhi'
    if therun>=15: syst_mod='radlo'
    if therun>=20: syst_mod='rad0'
    stringy = str(int(syspoints[therun%5][0]))+'_'+str(int(masses['1000024']))+'_'+str(int(syspoints[therun%5][1]))+'_'+syst_mod
    gentype='SS'
    decaytype='twostep'
    njets=1
    use_decays=False

if runArgs.runNumber in [152862,152863,152864, \
                 152865]:
    evt_multiplier = 4.0

evgenConfig.contact  = [ "genest@lpsc.in2p3.fr" ]
evgenConfig.keywords += ['squark','two_step']
evgenConfig.description = 'squark production two step without slepton in simplified model'

include ( 'MC12JobOptions/MadGraphControl_SimplifiedModelPostInclude.py' )

