##################################
# Stop pair-production with stop > b l
include('MC12JobOptions/MadGraphControl_SimplifiedModelPreInclude.py' )

# Assigned run numbers later - 400k+ for now
therun = runArgs.runNumber-202632
if therun>=0 and therun<10:
    masses['1000006'] = 100*therun+100 # 50 GeV scan over stop masses, 20 points
    stringy = str(masses['1000006']) # Goes into the file name
    gentype='TT' # stop-stop
    decaytype='directBL' # your magic word
    njets=1 # Number of jets in MadGraph
    evgenLog.info('Registered generation of stop pair production, stop to bl; grid point '+str(therun)+' decoded into mass ' + str(masses['1000006']) + ', with ' + str(njets) + ' jets.')
    use_decays=False # To turn on decays in MadGraph
    evt_multiplier = 20.0

evgenConfig.contact  = [ "bjackson@cern.ch" ]
evgenConfig.keywords += ['stop']
evgenConfig.description = 'stop direct pair production with simplified model'
evgenConfig.minevents=50000

# Set number of events and event multiplier for each data set based on stop mass
if masses['1000006'] == 100:
    evt_multiplier = 40.0
    evgenConfig.minevents = 100000
if masses['1000006'] == 200:
    evt_multiplier = 40.0
    evgenConfig.minevents = 100000
if masses['1000006'] == 300:
    evt_multiplier = 40.0
    evgenConfig.minevents = 80000
if masses['1000006'] == 400:
    evt_multiplier = 40.0
    evgenConfig.minevents = 70000
if masses['1000006'] == 500:
    evt_multiplier = 20.0
    evgenConfig.minevents = 60000
if masses['1000006'] == 600:
    evt_multiplier = 20.0
    evgenConfig.minevents = 50000
if masses['1000006'] == 700:
    evt_multiplier = 20.0
    evgenConfig.minevents = 40000
if masses['1000006'] == 800:
    evt_multiplier = 20.0
    evgenConfig.minevents = 30000
if masses['1000006'] == 900:
    evt_multiplier = 20.0
    evgenConfig.minevents = 10000
if masses['1000006'] == 1000:
    evt_multiplier = 20.0
    evgenConfig.minevents = 10000

include ( 'MC12JobOptions/MadGraphControl_SimplifiedModelPostInclude.py' )
##################################
